#-----------------------------------------------------------------------------
# Copyright 2008, Victor Liu
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Version History:
#   2006.Dec.09     v1.0    Initial release
#   2008.Jan.25     v1.1    Bug fixes; easier to use; remove grid option
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Usage: 
# Place this collection of files in your plugins directory.  At the Ruby 
# console, enter 
#   > load 'bez-patch/bez-patch.rb'
# and this will load the other required files (see list of requires below
# for tree structure).  If you wish to have this always loaded at startup,
# move only this file up one level.
#
# Menu Items:
#   Draw > Bezier Patch
#
# Context Menu Items:
#   Edit Bezier Patch
#-----------------------------------------------------------------------------

require 'sketchup.rb'
require 'bez-patch/BezPatch.rb'
require 'bez-patch/BezPatchTool.rb'
require 'bez-patch/BezPatchEdit.rb'
require 'util/AxisLock.rb'

if (not file_loaded?("bez-patch.rb"))
    add_separator_to_menu("Draw")
    UI.menu("Draw").add_item("Bezier Patch") { BezPatchTool.select_tool }
    # UI.menu("Draw").add_item("Bezier Grid") { BezPatchTool.select_grid_tool }
    
    # Add a context menu handler for editing the patch.
    UI.add_context_menu_handler do |menu|
        if ((sel = BezPatch.selected_patch) != nil)
            type = sel.get_attribute('BezPatch', 'bezType')
            menu.add_separator
            menu.add_item("Edit Bezier #{type}") { BezPatchEdit.select_tool }
        end
    end
end

file_loaded("bez-patch.rb")
