#-----------------------------------------------------------------------------
# Copyright 2006, Victor Liu
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

class AxisLock
    attr_reader :origin, :axis
    
    def initialize(x, y, origin, axis)
        @x0 = x
        @y0 = y
        @origin = origin
        @axis = (axis.unitvector?) ? axis : axis.normalize
    end
    
    def offset_point(x, y, view)
        camera = view.camera
        dx = (x - @x0) * @axis.dot(camera.xaxis)
        dy = (y - @y0) * @axis.dot(camera.yaxis)
        cam_dist = camera.eye.distance(ORIGIN)
        # Y direction is + going down
        ds = (dx + -dy) * (cam_dist**2) * 0.000001
        vec = Geom::Vector3d.new(ds*@axis.x, ds*@axis.y, ds*@axis.z)
        offset_pt = @origin.offset(vec)
        return offset_pt
    end
end
        